# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# This file is in the public domain
### END LICENSE
import subprocess
import gettext
from gettext import gettext as _
gettext.textdomain('hardwareinfo')

from gi.repository import Gtk # pylint: disable=E0611
import logging
logger = logging.getLogger('hardwareinfo')

from hardwareinfo_lib import Window
from hardwareinfo.AboutHardwareinfoDialog import AboutHardwareinfoDialog
from hardwareinfo.PreferencesHardwareinfoDialog import PreferencesHardwareinfoDialog

# See hardwareinfo_lib.Window.py for more details about how this class works
class HardwareinfoWindow(Window):
    __gtype_name__ = "HardwareinfoWindow"
    
    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the main window"""
        super(HardwareinfoWindow, self).finish_initializing(builder)

        self.AboutDialog = AboutHardwareinfoDialog
        self.PreferencesDialog = PreferencesHardwareinfoDialog

        # Code for other initialization actions should be added here.


    def on_raminfo_clicked(self, widget):
        command = "sudo dmidecode -t 16"
        self.writetest = self.builder.get_object("textview1")

        buffer = self.writetest.get_buffer()
        result = subprocess.check_output(command.split())
        buffer.set_text(result)

    def on_compraminfo_clicked(self, widget):

         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t memory;sudo lshw -C memory; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_lsusb_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("lsusb;hwinfo --usb; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_listhardware_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("hwinfo --short; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)
        
    def on_listhardwarelong_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("hwinfo; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)



    def on_meminfo_clicked(self, widget):
        command = "cat /proc/meminfo"
        self.writetest = self.builder.get_object("textview1")

        buffer = self.writetest.get_buffer()
        result = subprocess.check_output(command.split())
        buffer.set_text(result)

    def on_freemem_clicked(self, widget):
        command = "free -m"
        self.writetest = self.builder.get_object("textview1")

        buffer = self.writetest.get_buffer()
        result = subprocess.check_output(command.split())
        buffer.set_text(result)


    def on_vga_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("lspci | grep VGA;sudo lshw -C video;hwinfo --gfxcard; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_network_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("lspci | egrep -i --color 'network|ethernet';hwinfo --netcard; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_networkmore_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo lshw -class network; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_ipconfig_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("ifconfig -a;iwconfig;ip a; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_netstatus_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("cat /proc/net/dev; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_logeduser_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("w;who; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_route_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("route; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_demicode_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_businfo_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo lshw -businfo; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_geninfo_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo lshw -short; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_allinfo_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo lshw; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)



    def on_bluetooth_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("hwinfo --bluetooth; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)



    def on_cpuinfo_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t 4;cat /proc/cpuinfo; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_eth0_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo ethtool eth0; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_eth1_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo ethtool eth1; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_bootimage_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("cat /proc/cmdline; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_modules_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("cat /proc/modules; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_webcam_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.call("LD_PRELOAD=/usr/lib/libv4l/v4l2convert.so mplayer tv:// \
    -tv driver=v4l2:width=640:height=420:fps=30:device=/dev/video0 -vo x11", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_authlog_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo cat /var/log/auth.log; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_audio_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("lspci | grep 'Audio device';sudo lshw -C sound;hwinfo --sound; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_bridge_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("lspci | grep 'Host bridge';hwinfo --bridge; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_cdrom_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("hwinfo --cdrom; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)



    def on_kerndrive_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("lspci -k; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_kernmodules_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("lsmod; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_bios_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t 0;hwinfo --bios; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_motherboard_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t 2; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_battery_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t 22; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_product_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t 1; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_port_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t 8; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_slot_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t 9; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_temp_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo dmidecode -t 28; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_hddinfo_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo hdparm -I /dev/sda;hwinfo --disk; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_partition_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo fdisk -l; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_space_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("df -hT; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_opengl_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("glxinfo  | grep version;glxinfo  | grep render;glxinfo  | grep rendering; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_infohtml_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("cd;sudo lshw -html > hardware_info.html;firefox hardware_info.html;sleep 3;sudo rm hardware_info.html; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)



    def on_uname_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("cat /proc/version;lsb_release -a; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_bootlog_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo cat /var/log/boot.log; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_opengl_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("glxinfo  | grep version;glxinfo  | grep render;glxinfo  | grep rendering; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_disk1_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo hdparm -t /dev/sda; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)
    def on_disk2_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo hdparm -t /dev/sdb; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)



    def on_dmesglog_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo cat /var/log/dmesg; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_kernlog_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo cat /var/log/kern.log; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_syslog_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo cat /var/log/syslog; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_xorg0log_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo cat /var/log/Xorg.0.log; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_xorg8log_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo cat /var/log/Xorg.8.log; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_udevlog_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo cat /var/log/udev; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_rmlogs_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("sudo rm -v /var/log/lastlog var/log/*.gz /var/log/*log*1; sudo rm -v /var/log/upstart/*gz;sudo rm -v /var/log/*.gz;sudo rm -v /var/log/*log*1;sudo rm -v /var/log/*log*2;sudo rm -v /var/log/*old;sudo cat /dev/null > /var/log/cups/*gz;sudo cat /dev/null > /var/log/installer/casper.log;sudo cat /dev/null > /var/log/installer/partman;sudo cat /dev/null > /var/log/installer/syslog;sudo cat /dev/null > /var/log/lightdm/lightdm.log;sudo cat /dev/null > /var/log/lightdm/x-0-greeter.log;sudo cat /dev/null > /var/log/installer/*gz;sudo cat /dev/null > /var/log/upstart/mysql.log;sudo cat /dev/null > /var/log/upstart/*gz;sudo cat /dev/null > /var/log/upstart/ureadahead.log;sudo cat /dev/null > /var/log/apt/history.log;sudo cat /dev/null > /var/log/apt/term.log;sudo rm -v /var/log/lightdm/*old;sudo cat /dev/null > /var/log/cups/*gz;sudo cat /dev/null > /var/log/boot.log;sudo cat /dev/null > /var/log/Xorg.8.log;sudo cat /dev/null > /var/log/Xorg.0.log;sudo cat /dev/null > /var/log/dpkg.log;sudo cat /dev/null > /var/log/wtmp;sudo cat /dev/null > /var/log/ConsoleKit/history;sudo cat /dev/null > /var/log/aptitude;sudo cat /dev/null > /var/log/udev;sudo cat /dev/null > /var/log/kern.log;sudo cat /dev/null > /var/log/syslog.1;sudo cat /dev/null > /var/log/syslog;sudo cat /dev/null > /var/log/auth.log;sudo cat /dev/null > /var/log/alternatives.log;sudo cat /dev/null > /var/log/uvcdynctrl-udev.log;sudo cat /dev/null > /var/log/pm-powersave.log;sudo cat /dev/null > /var/log/dpkg.log;sudo cat /dev/null > /var/log/syslog;sudo cat /dev/null > /var/log/jockey.log.1;sudo cat /dev/null > /var/log/dmesg;sudo cat /dev/null > /var/log/bootstrap.log; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_printenv_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("printenv; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)


    def on_pstree_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("pstree -au; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_psaux_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("ps aux; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)

    def on_alias_clicked(self, widget):
         self.writetest = self.builder.get_object("textview1")
         buffer = self.writetest.get_buffer()
         result = subprocess.check_output("cat ~/.bashrc; exit 0", stderr=subprocess.STDOUT, shell=True)        
         buffer.set_text(result)
